#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "entry.h"

#define T Entry_T
struct Entry_T {
  char *name;
  int namelen;
  int start;
  int end;
  int score;
  double significance;
  float info;
  char *hit;
};


static void
string_copy (char *s, char *t, int length) {
  while (--length >= 0) {
    *s++ = *t++;
  };
  *s = '\0';
}

T
Entry_new (char *name, int name_length, int start, int width,
	   int score, double significance, float info, char *hit) {
  int i, j;
  T entry = (T) malloc(sizeof(*entry));
  
  entry->name = (char *) calloc(name_length+1,sizeof(char));
  string_copy(entry->name,name,name_length);
  entry->start = start;
  entry->end = start + width;
  entry->score = score;
  entry->significance = significance;
  entry->info = info;
  entry->hit = (char *) calloc(strlen(hit)+1,sizeof(char));
  string_copy(entry->hit,hit,strlen(hit));
  return entry;
}
  
void
Entry_free (T *entry) {
  free((*entry)->hit);
  free((*entry)->name);
  free(*entry);
}

int
Entry_start (T entry) {
  return entry->start;
}

int
Entry_end (T entry) {
  return entry->end;
}

int
Entry_score (T entry) {
  return entry->score;
}

double
Entry_significance (T entry) {
  return entry->significance;
}

float
Entry_info (T entry) {
  return entry->info;
}

char *
Entry_name (T entry) {
  return entry->name;
}

char *
Entry_hit (T entry) {
  return entry->hit;
}

int
Entry_cmp (const void *x, const void *y) {
  T entry1, entry2;

  entry1 = * (T *) x;
  entry2 = * (T *) y;
  if (entry1->significance > entry2->significance) {
    return 1;
  } else if (entry1->significance < entry2->significance) {
    return -1;
  } else {
    return 0;
  }
}


void
Entry_print (T entry) {
  printf("%12.3e %7.2f %s\n",
	 entry->significance,entry->info,entry->name);
  printf("                %d-%d\t%s\n\n",
	 (entry->start)+1,(entry->end)+1,entry->hit);
}



